      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'APSCOM5.'
      INCLUDE 'PDFCOM.'

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)
      real*8 qmom(5)
      data qmom /2d0, 4d0, 6d0, 8d0, 10d0/
      external uvdvmomi,udmomi

      npartot=0
! Set the number of PDF sets
#ifdef ABKM09
      npartot=25
#endif
#ifdef JR09
      npartot=26
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs
      kschemepdf=0
      kordpdf=2
 
      do kpdfset=0,npartot
!  Fill the PDF grid for the set #kpdfset

        call pdffillgrid

        do i=1,5
!  Fill the average momenta of the quark isospin asymmetries
          termplus(1,kpdfset,i)=pdfmom(1,qmom(i)**2,uvdvmomi)
          termplus(2,kpdfset,i)=pdfmom(1,qmom(i)**2,udmomi)
        end do
      end do

      print *,' The first moments (average momentum)',
     -' of the quark distribution isospin asymmetries',
     -' (first column: factorization scale in GeV^2,',
     -' second column: (u_V-d_V) asymmetry with the uncertainty,',
     -' third column: (u+ubar-d-dbar) asymmetry with the uncertainty).'

      do i=1,5

        do klum=1,2
          termdisp(klum,i)=0.

          do kpdfset=1,npartot          
            termdisp(klum,i)=termdisp(klum,i)
     +    +(termplus(klum,kpdfset,i)-termplus(klum,0,i))**2
          enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#ifdef ABKM09
          termdisp(klum,i)=sqrt(termdisp(klum,i))
#else
          termdisp(klum,i)=sqrt(termdisp(klum,i)/2.)
#endif

        end do

        write (*,fmt='(e13.4,3(e13.4,a2,e10.4))') qmom(i)**2
     ,        ,termplus(1,0,i),'+-',termdisp(1,i)
     ,        ,termplus(2,0,i),'+-',termdisp(2,i)
      end do

      stop
      end
c-----------------------
      real*8 function pdfmom(n,q2,qmomi)
      implicit real*8 (a-h,o-z)

      common /forpdfmom/ q2rep,nmom
      external qmomi

      nmom=n-1
      q2rep=q2
      call gauss2(qmomi,log(1d-5),0d0,6,df,eps)
      pdfmom=df

      return
      end
c----------------------------
      real*8 function uvdvmomi(t)
      implicit real*8 (A-H,O-Z)

      INCLUDE 'PDFCOM.'

      common /forpdfmom/ q2rep,nmom
      xb=exp(t)

      uvdvmomi=(xqg(4,xb,q2rep,kschemepdf)-xqg(5,xb,q2rep,kschemepdf)
     -       -xqg(2,xb,q2rep,kschemepdf)+xqg(3,xb,q2rep,kschemepdf))
     *       *xb**(nmom+1)

      return
      end
c----------------------------
      real*8 function udmomi(t)
      implicit real*8 (A-H,O-Z)

      INCLUDE 'PDFCOM.'

      common /forpdfmom/ q2rep,nmom
      xb=exp(t)

      udmomi=(xqg(4,xb,q2rep,kschemepdf)+xqg(5,xb,q2rep,kschemepdf)
     -       -xqg(2,xb,q2rep,kschemepdf)-xqg(3,xb,q2rep,kschemepdf))
     *       *xb**(nmom+1)

      return
      end
